/*
QUSOFT MICROSYSTMES
1869

Classe: TBranch - Type Branch

Hirarchie:
TObject -> TBranch
*/

/*
		Copyright 2001 Frdric Brown
*/

/*
    This file is part of Gundealer.

    Gundealer is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    Gundealer is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Gundealer; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

/**
 * The TBranch class represents a 1869's branch.
*/

//Structure de l'objet de Type Branch extension de TObject
typedef struct Branch {
	char *class; //Le nom de la classe
	char *super; //Le nom de la superclasse
	struct Object* 	(*clone) 		(struct Object*);
	BOOL 						(*equals) 	(struct Object*, struct Object*);
	void 						(*finalize) (struct Branch*);
	TString* 				(*toString) (struct Object*);
	TPort* port;
	float money;
	TVector* stock;
} TBranch;

//Dclaration des constructeurs
TBranch* TBranch0(TPort*);

//Dclaration des mthodes
void		 	TBranch_finalize	(TBranch*);

/**
 * Ce constructeur instancie un objet de Type Port.
 @since Release 1.0
*/
TBranch* TBranch0 (TPort* port) {
	TBranch *this = (TBranch*)malloc(sizeof(TBranch));
	
	this->class  = "TBranch";
	this->super  = "TObject";
	
	this->clone    = TObject_clone;
	this->equals   = TObject_equals;
	this->finalize = TBranch_finalize;
	this->toString = TObject_toString;
	
	this->port 	= port;
	this->money	= 0;
	this->stock	= TVector0();
	
	return this;
}

void TBranch_finalize	(TBranch* this) {
	
	int i;
	TObject *obj;
	
	for (i = 0; i < this->stock->size; i++)
	{
		obj = (TObject*)this->stock->elementAt(this->stock, i);
		obj->finalize(obj);
	}
	
	this->stock->finalize(this->stock);
	
	free(this);
}
