/*
QUSOFT MICROSYSTMES
C Object Oriented Language

Classe: TComponentNetwork - Type ComponentNetwork

Hirarchie:
TObject -> TComponentNetwork
*/

/*
	Copyrigth 2001-2002 Frdric Brown
*/

/*
    This file is part of COOL.

    COOL is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    COOL is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with COOL; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

/**
 * La classe TComponentNetwork reprsente un rseau de TRadioButtons.
 @since Release 1.0
*/

//Structure de l'objet de Type ComponentNetwork extension de TObject
typedef struct ComponentNetwork {
	char *class; //Le nom de la classe
	char *super; //Le nom de la superclasse
	struct ComponentNetwork* 		(*clone) 		(struct ComponentNetwork*);
	BOOL 												(*equals) 	(struct Object*, struct Object*);
	void 												(*finalize) (struct ComponentNetwork*);
	TString* 										(*toString) (struct Object*);
	TComponent* active;
} TComponentNetwork;

//Dclaration des constructeurs
TComponentNetwork* TComponentNetwork0();

//Dclaration des mthodes
TComponentNetwork* 	TComponentNetwork_clone 		(TComponentNetwork*);
void 								TComponentNetwork_finalize	(TComponentNetwork*);

/**
 * Ce constructeur instancie un objet de Type ComponentNetwork.
 @since Release 1.0
*/
TComponentNetwork* TComponentNetwork0 () {
	TComponentNetwork *this = (TComponentNetwork*)malloc(sizeof(TComponentNetwork));
	
	this->class  = "TComponentNetwork";
	this->super  = "TObject";
	
	this->clone    	= TComponentNetwork_clone;
	this->equals   	= TObject_equals;
	this->finalize 	= TComponentNetwork_finalize;
	this->toString 	= TObject_toString;
	
	this->active = NULL;
	
	return this;
}

/**
 * Cette mthode retourne un objet de Type ComponentNetwork qui est une copie de l'objet.
 @return clone - Une copie de l'objet.
 @since Release 1.0
*/
TComponentNetwork* TComponentNetwork_clone (TComponentNetwork* this) {

	TComponentNetwork *clone;
	
	clone = TComponentNetwork0();
	
	clone->active = this->active;
	
	return clone;
}

/**
 * Cette mthode libre l'espace mmoire occupe par l'objet, dtruisant ce dernier.
 @since Release 1.0
*/
void TComponentNetwork_finalize(TComponentNetwork* this) {

		TRY {
			free(this);	
		}
		ONERR {}
		ENDTRY
}
